/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Method Call Action</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Invokes a method using Java's reflection mechanism.
 * If it is not a static method, a value for the implicit this parameter is
 * required. The result of thisParameterValue is used for this purpose. <!--
 * end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlcallactions.MethodCallAction#getMethodName <em>Method
 * Name</em>}</li>
 * <li>{@link de.mdelab.mlcallactions.MethodCallAction#getMethodClassName <em>
 * Method Class Name</em>}</li>
 * <li>{@link de.mdelab.mlcallactions.MethodCallAction#getThisParameterValue
 * <em>This Parameter Value</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction()
 * @model
 * @generated
 */
public interface MethodCallAction extends ParameterizedCallAction
{
	/**
	 * Returns the value of the '<em><b>Method Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> The
	 * name of the method to invoke. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Method Name</em>' attribute.
	 * @see #setMethodName(String)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_MethodName()
	 * @model required="true"
	 * @generated
	 */
	String getMethodName();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.MethodCallAction#getMethodName
	 * <em>Method Name</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Method Name</em>' attribute.
	 * @see #getMethodName()
	 * @generated
	 */
	void setMethodName(String value);

	/**
	 * Returns the value of the '<em><b>Method Class Name</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
	 * The class that contains the method to invoke. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Method Class Name</em>' attribute.
	 * @see #setMethodClassName(String)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_MethodClassName()
	 * @model required="true"
	 * @generated
	 */
	String getMethodClassName();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.MethodCallAction#getMethodClassName
	 * <em>Method Class Name</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Method Class Name</em>' attribute.
	 * @see #getMethodClassName()
	 * @generated
	 */
	void setMethodClassName(String value);

	/**
	 * Returns the value of the '<em><b>This Parameter Value</b></em>'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> If the method is not static, the result of
	 * thisParameterValue is used as the "this" parameter. <!-- end-model-doc
	 * -->
	 * 
	 * @return the value of the '<em>This Parameter Value</em>' containment
	 *         reference.
	 * @see #setThisParameterValue(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getMethodCallAction_ThisParameterValue()
	 * @model containment="true"
	 * @generated
	 */
	MLExpression getThisParameterValue();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.MethodCallAction#getThisParameterValue
	 * <em>This Parameter Value</em>}' containment reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>This Parameter Value</em>'
	 *            containment reference.
	 * @see #getThisParameterValue()
	 * @generated
	 */
	void setThisParameterValue(MLExpression value);

} // MethodCallAction
